/*
**	cut.c
*/
#include <stdio.h>
#include <stdlib.h>

int getshort()
	{
	int c1;
	c1= getchar();
	return getchar()<<8|c1;
	}

int getint()
	{
	int c1= getshort();
	return getshort()<<16|c1;
	}

int cmp4(char* c)
	{
	int t;
	t= getchar(); if(t!=*c++) return 1;
	t= getchar(); if(t!=*c++) return 1;
	t= getchar(); if(t!=*c++) return 1;
	t= getchar(); if(t!=*c++) return 1;
	return 0;
	}

int putch(char* c)
	{
	int i;
	for(i=0; *c && i<8; i++) putchar(*c++);
	}

int putshort(i)
	{
	putchar(i&255);
	putchar((i>>8)&255);
	}

int putint(i)
	{
	putshort(i&65535);
	putshort((i>>16)&65535);
	}

main(int argc, char **argv)
	{
	int	c,cnt=0;
	int	start, end;
	char	*cmd= *argv;
	int	t;
	int	fsize;
	int	fsize2;
	int	lengf;
	int	nch;
	int	frq;
	int	avbps;
	int	bal;
	int	bps;

	if(cmp4("RIFF")){ fprintf(stderr,"There is no RIFF\n"); exit(1); }
	fsize= getint()+8;
	fprintf(stderr,"file size =%d \n",fsize);
	if(cmp4("WAVE")){ fprintf(stderr,"There is no WAVE\n"); exit(1); }
	if(cmp4("fmt ")){ fprintf(stderr,"There is no fmt \n"); exit(1); }
	lengf=  getint();
	fprintf(stderr,"format chunk %d (should be >=16)\n",lengf);
	if((t=getshort())!=1) { fprintf(stderr,"Warning: WAVE FORMAT should be PCM=1 %d\n",t); }
	nch= getshort();
	fprintf(stderr,"number of channels=%d\n",nch);
	frq= getint();
	fprintf(stderr,"frq=%d\n",frq);
	avbps= getint();
	fprintf(stderr,"average bytes per sec= %d\n",avbps);
	bal= getshort();
	fprintf(stderr,"block align= %d\n",bal);
	bps= getshort();
	fprintf(stderr,"bits per sample= %d\n",bps);
	if(cmp4("data")){ fprintf(stderr,"There is no data\n"); exit(1); }
	fsize2= getint();
	
	if(argc!=3){ fprintf(stderr,"Usage:%s startbyte endbyte\n",cmd); exit(1); }
	argc--; argv++;
	start= atoi(*argv);
	argc--; argv++;
	end= atoi(*argv);
	fprintf(stderr,"%s: start=%d end=%d\n",cmd,start,end);

	if(start<44 || end <= start)
	fprintf(stderr,"start and end should be: 44 <= start < end\n");

	putch("RIFF");
	putint(end-start+44-8);
	putch("WAVE");
	putch("fmt ");
	putint(16);
	putshort(1);
	putshort(nch);
	putint(frq);
	putint(avbps);
	putshort(bal);
	putshort(bps);
	putch("data");
	putint(end-start);

	while((c=getchar())!=EOF) if(++cnt==start)break;
	while((c=getchar())!=EOF){ putchar(c); if(++cnt==end)break; }
	}
